<?php
require_once __DIR__ . '/../vendor/autoload.php';

use Square\SquareClient;
use Square\LocationsApi;
use Square\Exceptions\ApiException;
use Square\Http\ApiResponse;
use Square\Models\CreateCustomerRequest;
use Square\Models\ListLocationsResponse;
use Square\Environment;

if ( empty( $_ENV ) ) {
	$dotenv = Dotenv\Dotenv::createImmutable( __DIR__ );
	$dotenv->load();
	$dotenv->required(
		array(
			'SQUARE_TOKEN',
		)
	);
}

$client = new SquareClient([
    'accessToken' => $_ENV['SQUARE_TOKEN'],
    'environment' => Environment::SANDBOX,
]);

try {
    $locationsApi = $client->getLocationsApi();
    $apiResponse = $locationsApi->listLocations();

    if ($apiResponse->isSuccess()) {
        $listLocationsResponse = $apiResponse->getResult();
        $locationsList = $listLocationsResponse->getLocations();
        foreach ($locationsList as $location) {
        print_r($location);
        }
    } else {
        print_r($apiResponse->getErrors());
    }
} catch (ApiException $e) {
    print_r("Recieved error while calling Square: " . $e->getMessage());
} 

$date = new DateTime();

$date->modify("-1 days")->format(DATE_RFC3339);

echo $date;


$object_types = ['ITEM'];
$body = new \Square\Models\SearchCatalogObjectsRequest();
$body->setObjectTypes($object_types);
$body->setIncludeDeletedObjects(true);
$body->setIncludeRelatedObjects(false);
$body->setBeginTime($date);

$api_response = $client->getCatalogApi()->searchCatalogObjects($body);

if ($api_response->isSuccess()) {
    $catalog = $api_response->getResult();
	foreach($catalog as $item){		
		if($item->is_deleted){
			delete_shopify_item(item);
		} else {
			update_shopify_item(item);
		}
	}
	
} else {
    $errors = $api_response->getErrors();
}

public function update_shopify_item($item) {
	
}
public function delete_shopify_item($item) {
	
}



